/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var Day = (function (_React$Component) {
  _inherits(Day, _React$Component);

  function Day() {
    var _this = this;

    _classCallCheck(this, Day);

    _get(Object.getPrototypeOf(Day.prototype), 'constructor', this).apply(this, arguments);

    this.onClick = function () {
      if (_this.props.onClick) {
        _this.props.onClick(_this.props.date);
      }
    };
  }

  _createClass(Day, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var date = _props.date;
      var active = _props.active;
      var outOfRange = _props.outOfRange;
      var showToday = _props.showToday;
      var today = _props.today;

      var props = _objectWithoutProperties(_props, ['date', 'active', 'outOfRange', 'showToday', 'today']);

      return _react2['default'].createElement(
        _Button2['default'],
        _extends({
          size: { width: 32, height: 32 },
          dimmed: outOfRange,
          active: active
        }, props, {
          tabIndex: -1,
          onClick: this.onClick }),
        date.date()
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      date: _react.PropTypes.object,
      active: _react.PropTypes.bool,
      outOfRange: _react.PropTypes.bool,
      onClick: _react.PropTypes.func
    },
    enumerable: true
  }]);

  return Day;
})(_react2['default'].Component);

exports['default'] = Day;
module.exports = exports['default'];
