/**
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var Layer = (function (_React$Component) {
  _inherits(Layer, _React$Component);

  _createClass(Layer, null, [{
    key: 'propTypes',
    value: {
      didMount: _react.PropTypes.func,
      didUpdate: _react.PropTypes.func,
      willUnmount: _react.PropTypes.func,
      children: _react.PropTypes.node
    },
    enumerable: true
  }]);

  function Layer(props) {
    var _this = this;

    _classCallCheck(this, Layer);

    _get(Object.getPrototypeOf(Layer.prototype), 'constructor', this).call(this, props);

    this._didMount = function () {
      if (_this.props.didMount) {
        _this.props.didMount(_this._element);
      }
    };

    this._didUpdate = function () {
      if (_this.props.didUpdate) {
        _this.props.didUpdate(_this._element);
      }
    };

    this._element = null;
    this._component = null;
  }

  _createClass(Layer, [{
    key: 'render',
    value: function render() {
      return null;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._element = this._createElement();
      this._component = _reactDom2['default'].render(_react2['default'].Children.only(this.props.children), this._element, this._didMount);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this._component = _reactDom2['default'].render(_react2['default'].Children.only(this.props.children), this._element, this._didUpdate);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.willUnmount) {
        this.props.willUnmount(this._element);
      }
      _reactDom2['default'].unmountComponentAtNode(this._element);
      document.body.removeChild(this._element);
      this._element = null;
      this._component = null;
    }
  }, {
    key: '_createElement',
    value: function _createElement() {
      var element = document.createElement('div');
      element.style.zIndex = '15000';
      document.body.appendChild(element);
      return element;
    }
  }]);

  return Layer;
})(_react2['default'].Component);

exports['default'] = Layer;
module.exports = exports['default'];
