/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Minute = require('./Minute');

var _Minute2 = _interopRequireDefault(_Minute);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('./Icon');

var Icon = _interopRequireWildcard(_Icon);

var MinuteView = (function (_React$Component) {
  _inherits(MinuteView, _React$Component);

  function MinuteView() {
    var _this = this;

    _classCallCheck(this, MinuteView);

    _get(Object.getPrototypeOf(MinuteView.prototype), 'constructor', this).apply(this, arguments);

    this.onMinuteClick = function (minute) {
      var selectedDate = _this.props.selectedDate.minutes(minute);
      _this.props.onSelectedDate(selectedDate);
      _this.props.onClose();
    };
  }

  _createClass(MinuteView, [{
    key: 'render',
    value: function render() {
      var onClose = this.props.onClose;

      return _react2['default'].createElement(
        'div',
        { 'data-action': 'selectMinute' },
        _react2['default'].createElement(
          _Button2['default'],
          { size: { width: '100%' }, onClick: onClose },
          _react2['default'].createElement(Icon.Clock, null)
        ),
        _react2['default'].createElement(
          'table',
          null,
          _react2['default'].createElement(
            'tbody',
            null,
            _react2['default'].createElement(
              'tr',
              null,
              _react2['default'].createElement(_Minute2['default'], { minute: 0, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 5, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 10, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 15, onClick: this.onMinuteClick })
            ),
            _react2['default'].createElement(
              'tr',
              null,
              _react2['default'].createElement(_Minute2['default'], { minute: 20, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 25, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 30, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 35, onClick: this.onMinuteClick })
            ),
            _react2['default'].createElement(
              'tr',
              null,
              _react2['default'].createElement(_Minute2['default'], { minute: 40, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 45, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 55, onClick: this.onMinuteClick }),
              _react2['default'].createElement(_Minute2['default'], { minute: 60, onClick: this.onMinuteClick })
            )
          )
        )
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      onClose: _react.PropTypes.func.isRequired,
      selectedDate: _react.PropTypes.object.isRequired,
      onSelectedDate: _react.PropTypes.func.isRequired
    },
    enumerable: true
  }]);

  return MinuteView;
})(_react2['default'].Component);

exports['default'] = MinuteView;
module.exports = exports['default'];
