/**
 * @copyright 2015-present Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _lodashNoop = require('lodash/noop');

var _lodashNoop2 = _interopRequireDefault(_lodashNoop);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ui = require('../ui');

var Day = (function (_React$Component) {
  _inherits(Day, _React$Component);

  function Day() {
    var _this = this;

    _classCallCheck(this, Day);

    _get(Object.getPrototypeOf(Day.prototype), 'constructor', this).apply(this, arguments);

    this.onClick = function () {
      return _this.props.onClick(_this.props.date);
    };
  }

  _createClass(Day, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var date = _props.date;
      var active = _props.active;
      var outOfRange = _props.outOfRange;

      return _react2['default'].createElement(
        _ui.Button,
        {
          dim: outOfRange,
          active: active,
          tabIndex: -1,
          onClick: this.onClick },
        date.date()
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      date: _react2['default'].PropTypes.object,
      active: _react2['default'].PropTypes.bool,
      outOfRange: _react2['default'].PropTypes.bool,
      onClick: _react2['default'].PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      onClick: _lodashNoop2['default']
    },
    enumerable: true
  }]);

  return Day;
})(_react2['default'].Component);

exports['default'] = Day;
module.exports = exports['default'];
