/**
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _prometheusresearchReactUi = require('@prometheusresearch/react-ui');

var ReactUI = _interopRequireWildcard(_prometheusresearchReactUi);

var _Icon = require('./Icon');

var Icon = _interopRequireWildcard(_Icon);

var _ui = require('./ui');

var Paginator = (function (_React$Component) {
  _inherits(Paginator, _React$Component);

  function Paginator() {
    _classCallCheck(this, Paginator);

    _get(Object.getPrototypeOf(Paginator.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Paginator, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var onPrev = _props.onPrev;
      var onNext = _props.onNext;
      var onUp = _props.onUp;
      var title = _props.title;
      var children = _props.children;

      return React.createElement(
        ReactUI.Block,
        { width: 210 },
        React.createElement(
          ReactUI.Block,
          { textAlign: 'center', height: 30 },
          React.createElement(_ui.Button, {
            onClick: onPrev,
            icon: React.createElement(Icon.AngleLeft, null),
            style: { height: 30, width: 30, padding: 0 }
          }),
          React.createElement(
            _ui.Button,
            {
              onClick: onUp,
              width: 5 },
            title
          ),
          React.createElement(_ui.Button, {
            onClick: onNext,
            icon: React.createElement(Icon.AngleRight, null)
          })
        ),
        React.createElement(
          ReactUI.Block,
          null,
          children
        )
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      onPrev: React.PropTypes.func,
      onNext: React.PropTypes.func,
      onUp: React.PropTypes.func,
      title: React.PropTypes.node,
      children: React.PropTypes.node
    },
    enumerable: true
  }]);

  return Paginator;
})(React.Component);

exports['default'] = Paginator;
module.exports = exports['default'];
