/**
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactStylesheet = require('react-stylesheet');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var PaginatorControls = (0, _reactStylesheet.style)('div', {
  displayName: 'PaginatorControls',
  base: {
    height: 32,
    textAlign: 'center'
  }
});

var Paginator = (function (_React$Component) {
  _inherits(Paginator, _React$Component);

  function Paginator() {
    _classCallCheck(this, Paginator);

    _get(Object.getPrototypeOf(Paginator.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Paginator, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var onPrev = _props.onPrev;
      var onNext = _props.onNext;
      var onUp = _props.onUp;
      var title = _props.title;
      var children = _props.children;
      var stylesheet = _props.stylesheet;

      return _react2['default'].createElement(
        'div',
        null,
        _react2['default'].createElement(
          stylesheet.Controls,
          null,
          _react2['default'].createElement(
            _Button2['default'],
            { bold: true, onClick: onPrev, size: { width: '15%', height: 32 } },
            '‹'
          ),
          _react2['default'].createElement(
            _Button2['default'],
            { bold: true, onClick: onUp, size: { width: '70%' } },
            title
          ),
          _react2['default'].createElement(
            _Button2['default'],
            { bold: true, onClick: onNext, size: { width: '15%', height: 32 } },
            '›'
          )
        ),
        _react2['default'].createElement(
          'div',
          null,
          children
        )
      );
    }
  }], [{
    key: 'defaultProps',
    value: {
      stylesheet: {
        Controls: PaginatorControls
      }
    },
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      onPrev: _react.PropTypes.func,
      onNext: _react.PropTypes.func,
      onUp: _react.PropTypes.func,
      title: _react.PropTypes.node,
      children: _react.PropTypes.node
    },
    enumerable: true
  }]);

  return Paginator;
})(_react2['default'].Component);

exports['default'] = Paginator;
module.exports = exports['default'];
